
; CC8E Version 1.4F, Copyright (c) B Knudsen Data
; C compiler for the PIC18 microcontrollers
; ************  17. Jan 2021  12:10  *************

        processor  PIC18F252
        radix  DEC

        __config 0x300000, 0x0
        __config 0x300001, 0x25
        __config 0x300002, 0xE
        __config 0x300003, 0xE
        __config 0x300004, 0x0
        __config 0x300005, 0x1
        __config 0x300006, 0x81
        __config 0x300007, 0x0
        __config 0x300008, 0xF
        __config 0x300009, 0xC0
        __config 0x30000A, 0xF
        __config 0x30000B, 0xE0
        __config 0x30000C, 0xF
        __config 0x30000D, 0x40

STKPTR      EQU   0xFFC
TBLPTRU     EQU   0xFF8
TBLPTRH     EQU   0xFF7
TBLPTRL     EQU   0xFF6
TABLAT      EQU   0xFF5
PRODL       EQU   0xFF3
INTCON      EQU   0xFF2
INDF0       EQU   0xFEF
POSTINC0    EQU   0xFEE
FSR0H       EQU   0xFEA
FSR0        EQU   0xFE9
STATUS      EQU   0xFD8
WDTCON      EQU   0xFD1
ADCON0      EQU   0xFC2
ADCON1      EQU   0xFC1
SPBRG       EQU   0xFAF
RCREG       EQU   0xFAE
TXREG       EQU   0xFAD
TXSTA       EQU   0xFAC
RCSTA       EQU   0xFAB
EECON2      EQU   0xFA7
TRISC       EQU   0xF94
TRISB       EQU   0xF93
TRISA       EQU   0xF92
PORTC       EQU   0xF82
PORTB       EQU   0xF81
PORTA       EQU   0xF80
GIE         EQU   7
TRMT        EQU   1
BRGH        EQU   2
WR          EQU   1
WREN        EQU   2
FREE        EQU   4
CFGS        EQU   6
EEPGD       EQU   7
EEIF        EQU   4
RCIF        EQU   5
boot_OK     EQU   0
rxdata      EQU   0x01
bi          EQU   0x02
boot_tp     EQU   0x03
dmpadrh     EQU   0x93
dmpadrl     EQU   0x94
dmpdathrd   EQU   0x95
dmpdatlrd   EQU   0x96
dmpdathwr   EQU   0x97
dmpdatlwr   EQU   0x98
fadr        EQU   0x89
i           EQU   0x8B
j           EQU   0x8C
calc8       EQU   0x8D
pointr      EQU   0x8E
svfadr      EQU   0x8F
tpadrs      EQU   0x91
outcar      EQU   0x89
rcvdata     EQU   0x80
i_2         EQU   0x81
BCC         EQU   0x83
boot_fadr   EQU   0x84

        GOTO main

  ; FILE Srl_bootldr.c
                        ;/**********************************************************
                        ;		RS232 SERIAL BOOTLOADER
                        ; 
                        ; - All polled, no interrupt is used in this soft.
                        ; - All parameters must be set in the corresponding .h file.
                        ;************************************************************/
                        ;
                        ;#include "int18XXX.H"
                        ;#include "Srl_Bootldr.h"
                        ;
                        ;
                        ;/****** V E C T O R  R E M A P P I N G **************************/
                        ;
                        ;  /* -----------------------------------------------------------------
                        ;            INTERRUPTS HANDLER                
                        ; 	- interrups not used for bootloader
                        ; 	- for live soft, a simple jump to user interrupt handler
                        ; --------------------------------------------------------------------- */
                        ;
                        ;#pragma origin 0x008
        ORG 0x0008
                        ;
                        ;void hrdw_int_high( void)
                        ;{
hrdw_int_high
                        ;	#asm
                        ;	call UserHighIntServ		// call chgd in goto
        GOTO  UserHighIntServ
                        ;	#endasm
                        ;}
                        ;
                        ;#pragma origin 0x018
        ORG 0x0018
                        ;void hrdw_int_low(void)
                        ;{
hrdw_int_low
                        ;	#asm
                        ;	call UserLowIntServ		// call chgd in goto
        GOTO  UserLowIntServ
                        ;	#endasm
                        ;}
                        ;
                        ;/*------------- End Interrupts services --------------*/
                        ;
                        ;/********************************************************
                        ;     BOOTLOADER ROUTINES
                        ; **********************************************************/
                        ;
                        ;
                        ;void boot_writeflash (uns16 fadr) // 64 bytes at once in bufflash
                        ;{
boot_writeflash
                        ;	char i,j,calc8,pointr;
                        ;	uns16 svfadr, tpadrs;
                        ;	
                        ;	boot_OK = 1;
        BSF   0x00,boot_OK,0
                        ;	svfadr = fadr;
        MOVFF fadr,svfadr
        MOVFF fadr+1,svfadr+1
                        ;// erase row
                        ;	if (fadr >= 0x400)	// value must be above bootldr
        MOVLW 3
        CPFSGT fadr+1,1
        BRA   m009
                        ;	{
                        ;		TBLPTRU = 0;
        CLRF  TBLPTRU,0
                        ;		TBLPTRH = fadr.high8;
        MOVFF fadr+1,TBLPTRH
                        ;		TBLPTRL = fadr.low8;
        MOVFF fadr,TBLPTRL
                        ;		EEPGD = 1;
        BSF   0xFA6,EEPGD,0
                        ;		CFGS = 0;
        BCF   0xFA6,CFGS,0
                        ;		WREN = 1;
        BSF   0xFA6,WREN,0
                        ;		FREE = 1;
        BSF   0xFA6,FREE,0
                        ;		GIE = 0;
        BCF   0xFF2,GIE,0
                        ;		EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2,0
                        ;		EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2,0
                        ;		WR = 1;
        BSF   0xFA6,WR,0
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		while (FREE == 1);
m001    BTFSC 0xFA6,FREE,0
        BRA   m001
                        ;		EEIF = 0;
        BCF   0xFA1,EEIF,0
                        ;		WREN = 0;
        BCF   0xFA6,WREN,0
                        ;// Write datas
                        ;		tpadrs = fadr - 8;
        MOVLW 8
        SUBWF fadr,W,1
        MOVWF tpadrs,1
        MOVLW 0
        SUBWFB fadr+1,W,1
        MOVWF tpadrs+1,1
                        ;		for (calc8 = 0;calc8 != 8;calc8++)
        CLRF  calc8,1
m002    MOVF  calc8,W,1
        XORLW 8
        BZ    m005
                        ;		{
                        ;			TBLPTRU = 0;
        CLRF  TBLPTRU,0
                        ;			TBLPTRH = fadr.high8;
        MOVFF fadr+1,TBLPTRH
                        ;			TBLPTRL = fadr.low8;
        MOVFF fadr,TBLPTRL
                        ;			tableReadDec(); // dummy read to adjust TBLPTR
        TBLRD *-
                        ;			j = (char) calc8 * 8;
        MOVLW 8
        MULWF calc8,1
        MOVFF PRODL,j
                        ;			for (i = 0;i != 8;i++)
        CLRF  i,1
m003    MOVF  i,W,1
        XORLW 8
        BZ    m004
                        ;			{
                        ;				pointr = j + i;
        MOVF  i,W,1
        ADDWF j,W,1
        MOVWF pointr,1
                        ;				TABLAT = boot_bufflash[pointr];
        LFSR  0,256 
        ADDWF FSR0,1,0
        MOVFF INDF0,TABLAT
                        ;				tableWritePreInc();
        TBLWT +*
                        ;			}
        INCF  i,1,1
        BRA   m003
                        ;			EEPGD=1;
m004    BSF   0xFA6,EEPGD,0
                        ;			CFGS = 0;
        BCF   0xFA6,CFGS,0
                        ;			WREN = 1;
        BSF   0xFA6,WREN,0
                        ;			GIE = 0;
        BCF   0xFF2,GIE,0
                        ;			EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2,0
                        ;			EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2,0
                        ;			WR = 1;
        BSF   0xFA6,WR,0
                        ;			nop ();
        NOP  
                        ;			nop();
        NOP  
                        ;			EEIF = 0;
        BCF   0xFA1,EEIF,0
                        ;			WREN = 0;
        BCF   0xFA6,WREN,0
                        ;			fadr = fadr + 8;
        MOVLW 8
        ADDWF fadr,1,1
        MOVLW 0
        ADDWFC fadr+1,1,1
                        ;		}
        INCF  calc8,1,1
        BRA   m002
                        ;		WREN = 0;
m005    BCF   0xFA6,WREN,0
                        ;// Verify block just writen
                        ;		fadr = svfadr;
        MOVFF svfadr,fadr
        MOVFF svfadr+1,fadr+1
                        ;		TBLPTRU = 0;
        CLRF  TBLPTRU,0
                        ;		TBLPTRH = svfadr.high8;
        MOVFF svfadr+1,TBLPTRH
                        ;		TBLPTRL = svfadr.low8;
        MOVFF svfadr,TBLPTRL
                        ;		for(i = 0; i != 64; i++)
        CLRF  i,1
m006    MOVF  i,W,1
        XORLW 64
        BZ    m008
                        ;		{			
                        ;			tableReadInc();
        TBLRD *+
                        ;			calc8=TABLAT;
        MOVFF TABLAT,calc8
                        ;			j = boot_bufflash[i];
        LFSR  0,256 
        MOVF  i,W,1
        ADDWF FSR0,1,0
        MOVFF INDF0,j
                        ;			if (j != calc8)
        MOVF  j,W,1
        XORWF calc8,W,1
        BZ    m007
                        ;			{
                        ;				boot_OK = 0;
        BCF   0x00,boot_OK,0
                        ;				j = calc8;
        MOVFF calc8,j
                        ;				break;
        BRA   m008
                        ;			}
                        ;			if (boot_OK == 0) break;
m007    BTFSS 0x00,boot_OK,0
        BRA   m008
                        ;		}
        INCF  i,1,1
        BRA   m006
                        ;		if (boot_OK == 0)
m008    BTFSC 0x00,boot_OK,0
        BRA   m009
                        ;		{
                        ;			dmpadrh = svfadr.high8;
        MOVFF svfadr+1,dmpadrh
                        ;			dmpadrl = svfadr.low8;
        MOVFF svfadr,dmpadrl
                        ;			dmpdathrd = 0;
        CLRF  dmpdathrd,1
                        ;			dmpdatlrd = j;
        MOVFF j,dmpdatlrd
                        ;			dmpdathwr = boot_bufflash[pointr+1];
        LFSR  0,257 
        MOVF  pointr,W,1
        ADDWF FSR0,1,0
        MOVFF INDF0,dmpdathwr
                        ;			dmpdatlwr = boot_bufflash[pointr];
        LFSR  0,256 
        ADDWF FSR0,1,0
        MOVFF INDF0,dmpdatlwr
                        ;		}	
                        ;	}
                        ;}
m009    RETURN
                        ;
                        ;//  *** serial port routines
                        ;void boot_outsrl (char outcar)
                        ;	{
boot_outsrl
        MOVWF outcar,1
                        ;	while (TRMT == 0);
m010    BTFSS 0xFAC,TRMT,0
        BRA   m010
                        ;	#if defined(_18F25K50) || (_18F45K50)
                        ;	TXREG1 = outcar;
                        ;	#else
                        ;	TXREG = outcar;
        MOVFF outcar,TXREG
                        ;	#endif
                        ;	}
        RETURN
                        ;
                        ;char boot_waitsrl (void)
                        ;{
boot_waitsrl
                        ;while (RCIF == 0)
m011    BTFSC 0xF9E,RCIF,0
        BRA   m012
                        ;	{nop();
        NOP  
                        ;	nop();
        NOP  
                        ;	}
        BRA   m011
                        ;RCIF = 0;
m012    BCF   0xF9E,RCIF,0
                        ;#if defined(_18F25K50) || (_18F45K50)
                        ;return RCREG1;
                        ;#else
                        ;return RCREG;
        MOVF  RCREG,W,0
        RETURN
                        ;#endif
                        ;}
                        ;
                        ;void bootprocess (void)
                        ;{
bootprocess
                        ;// *** main bootloader
                        ;
                        ;	char rcvdata, i, j, BCC; 
                        ;	uns16 boot_fadr,btloop;
                        ;	GIE = 0;
        BCF   0xFF2,GIE,0
                        ;	char tp;
                        ;
                        ;/* host synch*/
                        ;	bi = 0;
        CLRF  bi,0
                        ;	boot_tp=0;
        CLRF  boot_tp,0
                        ;	while (bi == 0)
m013    TSTFSZ bi,0
        BRA   m014
                        ;	{
                        ;		rxdata = boot_waitsrl();
        RCALL boot_waitsrl
        MOVWF rxdata,0
                        ;		if (rxdata == 'R')
        MOVLW 82
        CPFSEQ rxdata,0
        BRA   m013
                        ;		{
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			rxdata = boot_waitsrl();
        RCALL boot_waitsrl
        MOVWF rxdata,0
                        ;
                        ;			if (rxdata == 'M')
        MOVLW 77
        CPFSEQ rxdata,0
        BRA   m013
                        ;			{
                        ;				nop();
        NOP  
                        ;				nop();
        NOP  
                        ;				rxdata = boot_waitsrl();
        RCALL boot_waitsrl
        MOVWF rxdata,0
                        ;				if (rxdata == 'b')
        MOVLW 98
        CPFSEQ rxdata,0
        BRA   m013
                        ;				{
                        ;					nop();
        NOP  
                        ;					nop();
        NOP  
                        ;					rxdata = boot_waitsrl();
        RCALL boot_waitsrl
        MOVWF rxdata,0
                        ;					if (rxdata == 't')
        MOVLW 116
        CPFSEQ rxdata,0
        BRA   m013
                        ;					{
                        ;						LED = LEDOFF;
        BCF   PORTB,1,0
                        ;						boot_outsrl ('b');			// Device reply with c to complete handshake
        MOVLW 98
        RCALL boot_outsrl
                        ;						boot_outsrl ('t');
        MOVLW 116
        RCALL boot_outsrl
                        ;						boot_outsrl (FLASHCAPACITY);
        MOVLW 32
        RCALL boot_outsrl
                        ;						bi = 1;
        MOVLW 1
        MOVWF bi,0
                        ;					}	
                        ;				}
                        ;			}
                        ;		} 
                        ;	}
        BRA   m013
                        ;
                        ;/* tfr data */
                        ;	boot_fadr = 0;
m014    CLRF  boot_fadr,1
        CLRF  boot_fadr+1,1
                        ;
                        ;// transfer format is :
                        ;// 27 as sart of block
                        ;// address high, address low, in hex.
                        ;// then 64 bytes follows, then check caracter
                        ;// When address is 0xff00: stop
                        ;
                        ;	while (boot_fadr != 0xFF00)	// must complete with address FF00 to stop tfr
m015    INCF  boot_fadr+1,W,1
        IORWF boot_fadr,W,1
        BZ    m022
                        ;	{
                        ;		while (boot_waitsrl() != 27);		// start of block 
m016    RCALL boot_waitsrl
        XORLW 27
        BNZ   m016
                        ;		rcvdata = boot_waitsrl();
        RCALL boot_waitsrl
        MOVWF rcvdata,1
                        ;		BCC = rcvdata;
        MOVFF rcvdata,BCC
                        ;		boot_fadr.high8 = rcvdata;
        MOVFF rcvdata,boot_fadr+1
                        ;		rcvdata = boot_waitsrl();
        RCALL boot_waitsrl
        MOVWF rcvdata,1
                        ;		BCC += rcvdata;
        ADDWF BCC,1,1
                        ;		boot_fadr.low8 = rcvdata;
        MOVFF rcvdata,boot_fadr
                        ;		if (boot_fadr == 0xFF00) break;
        INCF  boot_fadr+1,W,1
        IORWF boot_fadr,W,1
        BZ    m022
                        ;		for (i = 0;i!=64;i++)
        CLRF  i_2,1
m017    MOVF  i_2,W,1
        XORLW 64
        BZ    m018
                        ;		{
                        ;			rcvdata = boot_waitsrl();
        RCALL boot_waitsrl
        MOVWF rcvdata,1
                        ;			BCC += rcvdata;
        ADDWF BCC,1,1
                        ;			boot_bufflash[i] = rcvdata;
        LFSR  0,256 
        MOVF  i_2,W,1
        ADDWF FSR0,1,0
        MOVFF rcvdata,INDF0
                        ;		}
        INCF  i_2,1,1
        BRA   m017
                        ;#ifdef LED
                        ;		boot_tp++;
m018    INCF  boot_tp,1,0
                        ;		if (boot_tp == 5)
        MOVLW 5
        CPFSEQ boot_tp,0
        BRA   m019
                        ;		{
                        ;			LED = !LED;
        BTG   PORTB,1,0
                        ;			boot_tp=0;
        CLRF  boot_tp,0
                        ;		}
                        ;#endif	
                        ;		rcvdata = boot_waitsrl();	// BCC caracter
m019    RCALL boot_waitsrl
        MOVWF rcvdata,1
                        ;		if (rcvdata == BCC)  
        CPFSEQ BCC,1
        BRA   m021
                        ;		{
                        ;			boot_OK=1;		
        BSF   0x00,boot_OK,0
                        ;			boot_writeflash (boot_fadr);
        MOVFF boot_fadr,fadr
        MOVFF boot_fadr+1,fadr+1
        RCALL boot_writeflash
                        ;				if (boot_OK == 1)
        BTFSS 0x00,boot_OK,0
        BRA   m020
                        ;				{
                        ;					boot_outsrl (6);		// write is ok, reply ack
        MOVLW 6
        RCALL boot_outsrl
                        ;				}
                        ;				else
        BRA   m015
                        ;				{						// In case of error send some infos
                        ;					boot_outsrl (8);
m020    MOVLW 8
        RCALL boot_outsrl
                        ;					boot_outsrl (dmpadrh);
        MOVF  dmpadrh,W,1
        RCALL boot_outsrl
                        ;					boot_outsrl(dmpadrl);
        MOVF  dmpadrl,W,1
        RCALL boot_outsrl
                        ;					boot_outsrl(dmpdathrd);
        MOVF  dmpdathrd,W,1
        RCALL boot_outsrl
                        ;					boot_outsrl(dmpdatlrd);
        MOVF  dmpdatlrd,W,1
        RCALL boot_outsrl
                        ;					boot_outsrl(dmpdathwr);
        MOVF  dmpdathwr,W,1
        RCALL boot_outsrl
                        ;					boot_outsrl(dmpdatlwr);
        MOVF  dmpdatlwr,W,1
        RCALL boot_outsrl
                        ;				}
                        ;	
                        ;		}
                        ;		else
        BRA   m015
                        ;		{
                        ;				boot_outsrl (7);	// reply nack (comm error)
m021    MOVLW 7
        RCALL boot_outsrl
                        ;		}
                        ;	}
        BRA   m015
                        ;}
m022    RETURN
                        ;
                        ;void Initialize()
                        ;{
Initialize
                        ;	#if defined(_18F25K50) || (_18F45K50)
                        ;	OSCTUNE = 0x80; //3X PLL ratio mode selected
                        ;	OSCCON = 0x70;  //Switch to 16MHz HFINTOSC
                        ;	OSCCON2 = 0x10; //Enable PLL, SOSC, PRI OSC drivers turned off
                        ;	while(PLLRDY != 1);   //Wait for PLL lock
                        ;	ACTCON = 0x80;  //
                        ;		// all ports as digital at reset
                        ;	ANSELA = 0;
                        ;	ANSELB = 0;
                        ;	ANSELC = 0;
                        ;	ANSELD = 0;
                        ;	ANSELE = 0;
                        ;	// turn power off on all periph, must be indivually turned on
                        ;	PMD0 = 0xFF;
                        ;	PMD1 = 0xFF;
                        ;	PMD0.6 = 0;		//USART ena
                        ;	#endif
                        ;	INTCON = 0;  /* disable all interrupts */
        CLRF  INTCON,0
                        ;	STATUS = 0;
        CLRF  STATUS,0
                        ;	WDTCON = 0;
        CLRF  WDTCON,0
                        ;	PORTA = 0; 
        CLRF  PORTA,0
                        ;	PORTB = 0;
        CLRF  PORTB,0
                        ;	PORTC = 0;  
        CLRF  PORTC,0
                        ;	TRISA = bin(111111);
        MOVLW 63
        MOVWF TRISA,0
                        ;	TRISB = bin(11111111);
        SETF  TRISB,0
                        ;	TRISC = bin(11111111);
        SETF  TRISC,0
                        ;//	TRISD = 0b11111111;			// not valid for 28pins
                        ;	TrisLed
        BCF   TRISB,1,0
                        ;// next line not needed, just in case wrong manip made on previous lines
                        ;	GIE = 0;			// no interrupt, polling hrdw
        BCF   0xFF2,GIE,0
                        ;	clearRAM();
        LFSR  0,0 
        MOVLW 6
m023    CLRF  POSTINC0,0
        CPFSEQ FSR0H,0
        BRA   m023
                        ;	/* init USART 19.2 Kbps / 8 bits*/
                        ;
                        ;
                        ;
                        ;#if defined(_18F25K50) || (_18F45K50)
                        ;	TXSTA1 = 0b00100000;
                        ;	RCSTA1 = 0b10010000;
                        ;	BAUDCON1 = 0b01000000;
                        ;	SYNC = 0;
                        ;	BRGH = 0;
                        ;	BRG16 = 0;
                        ;	SPBRGH1 = 0;
                        ;	SPBRG1 = 38;
                        ;#else
                        ;	TXSTA = 0b00100000;
        MOVLW 32
        MOVWF TXSTA,0
                        ;	RCSTA = 0b10010000;
        MOVLW 144
        MOVWF RCSTA,0
                        ;	BRGH = 1;			//comment in case of baud error
        BSF   0xFAC,BRGH,0
                        ;	SPBRG = (char)BAUDGEN;
        MOVLW 64
        MOVWF SPBRG,0
                        ;#endif
                        ;#if defined(_18F2550) || (_18F4550)
                        ;	BAUDCON = 0b01000000;
                        ;	SYNC = 0;
                        ;	BRGH = 0;
                        ;	BRG16 = 0;
                        ;	SPBRGH = 0;
                        ;	SPBRG = 38;	
                        ;#endif
                        ;	
                        ;#if defined(_18F25K50) || (_18F45K50)
                        ;	bi = RCREG1;	// dummy reads to clear buffer.
                        ;	nop();
                        ;	bi = RCREG1;
                        ;#else
                        ;	bi = RCREG;	// dummy reads to clear buffer.
        MOVFF RCREG,bi
                        ;	nop();
        NOP  
                        ;	bi = RCREG;
        MOVFF RCREG,bi
                        ;#endif
                        ;}	
        RETURN
                        ;
                        ;void jumpusermain (void)
                        ;{
jumpusermain
                        ;
                        ;	STKPTR = 0;			// reset stack pointer, clear call to this proc
        CLRF  STKPTR,0
                        ;	#asm
                        ;		call usermain		// call chgd in goto
        GOTO  usermain
                        ;	#endasm
                        ;}	
                        ;
                        ;/************* RESET ENTRY POINT ***************/
                        ;void main( void)
                        ;{
main
                        ;	Initialize();
        RCALL Initialize
                        ;#ifdef LED
                        ;		LED = LEDOFF;
        BCF   PORTB,1,0
                        ;#endif
                        ;	ADCON0 = 0;
        CLRF  ADCON0,0
                        ;	ADCON1 = 7;
        MOVLW 7
        MOVWF ADCON1,0
                        ;	TrisSw = 0;
        BCF   TRISB,4,0
                        ;// test if switch pressed, otherwise jump to user code
                        ;	if (SWITCH == SwitchActivation)
        MOVLB 0
        BTFSC PORTB,4,0
        BRA   m024
                        ;	{
                        ;#ifdef LED
                        ;		LED = LEDON;
        BSF   PORTB,1,0
                        ;#endif
                        ;		bootprocess();
        RCALL bootprocess
                        ;	}
                        ;// if switch not pressed goto user startup
                        ;	jumpusermain ();
m024    RCALL jumpusermain
                        ;
                        ;}
        SLEEP
        RESET
                        ;
                        ;/* ---------------------------------------------------------
                        ;              DUMMY MAIN        
                        ; 	- This part is only here to generate the necessary
                        ; 	  adresses for the direct calls                           
                        ; ---------------------------------------------------------*/
                        ;
                        ;#pragma origin UserEntryAddress
        ORG 0x1000
                        ;void usermain( void)
                        ;{
usermain
                        ;// user code should start like the following code :
                        ;#asm
                        ;	call userreset
        GOTO  userreset
                        ;#endasm
                        ;}
                        ;
                        ;#pragma origin UserHInt
        ORG 0x1008
                        ;
                        ;void UserHighIntServ (void)
                        ;{
UserHighIntServ
                        ;}
        RETURN
                        ;#pragma origin UserLInt
        ORG 0x1018
                        ;void UserLowIntServ (void)
                        ;{
UserLowIntServ
                        ;}
        RETURN
                        ;
                        ;//  small example of structure of user code :	
                        ;void MainLoop (void)
                        ;{
MainLoop
                        ;}
        RETURN
                        ;
                        ;void SystemInit (void)
                        ;{
SystemInit
                        ;}		
        RETURN
                        ;void userreset ( void)
                        ;{
userreset
                        ;
                        ; 	SystemInit();
        RCALL SystemInit
                        ;	while (1)
                        ;	{
                        ;		TRISB.2=0;
m025    BCF   TRISB,2,0
                        ;		PORTB.2 = 1;
        BSF   PORTB,2,0
                        ;		MainLoop();
        RCALL MainLoop
                        ;	}	
        BRA   m025

        END


; *** KEY INFO ***

; 0x001000    2 word(s)  0 % : usermain
; 0x001008    1 word(s)  0 % : UserHighIntServ
; 0x001018    1 word(s)  0 % : UserLowIntServ
; 0x00101E    5 word(s)  0 % : userreset
; 0x000008    2 word(s)  0 % : hrdw_int_high
; 0x000018    2 word(s)  0 % : hrdw_int_low
; 0x00001C  138 word(s)  0 % : boot_writeflash
; 0x000130    6 word(s)  0 % : boot_outsrl
; 0x00013C    8 word(s)  0 % : boot_waitsrl
; 0x00014C  118 word(s)  0 % : bootprocess
; 0x000238   31 word(s)  0 % : Initialize
; 0x000276    3 word(s)  0 % : jumpusermain
; 0x00027C   14 word(s)  0 % : main
; 0x00101A    1 word(s)  0 % : MainLoop
; 0x00101C    1 word(s)  0 % : SystemInit

; RAM usage: 93 bytes (19 local), 1443 bytes free
; Maximum call level: 2
; Total of 335 code words (2 %)
